package de.intevation.gnv.action;

import de.intevation.gnv.action.sessionmodel.SessionModel;
import de.intevation.gnv.action.sessionmodel.SessionModelFactory;

import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClient;
import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClientFactory;

import de.intevation.gnv.artifactdatabase.objects.ArtifactObject;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


/**
 * @author Ingo Weinzierl <ingo.weinzierl@intevation.de>
 *
 */
public class PreviousArtifactStepAction extends DescribeUIAction {


    public static final String URL_STATE_KEY = "target";

    private static Logger logger =
        Logger.getLogger(PreviousArtifactStepAction.class);


    public PreviousArtifactStepAction() {
        super();
    }


    @Override
    public ActionForward execute(
        ActionMapping       mapping,
        ActionForm          form,
        HttpServletRequest  request,
        HttpServletResponse response
    ) throws Exception {

        String id = request.getSession().getId();

        SessionModel session = SessionModelFactory.getInstance().getSessionModel(
            request);

        // TODO check if target is reachable

        ArtifactDatabaseClientFactory f =
            ArtifactDatabaseClientFactory.getInstance();
        ArtifactDatabaseClient client   =
            f.getArtifactDatabaseClient(getLocale(request));

        ArtifactObject artifactFactory = session.getSelectedArtifactFactory();
        ArtifactObject currentArtifact = session.getCurrentArtifact();

        String target = (String) request.getParameter(URL_STATE_KEY);
        logger.debug("Step back to previous state: " + target);

        client.doAdvance(
            artifactFactory,
            currentArtifact,
            target
        );

        return super.execute(mapping, form, request, response);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
